#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *
import os, string, sys
import math
from array import array
#Author: Tin Tran
#bezier helper functions tested in codeskulptor.org
#http://www.codeskulptor.org/#user41_3ejFX0pINN_6.py

#c=(17.0, 91.0, 52.0, 65.0, 91.0, 35.0, 163.0, 166.0, 274.66666666666663, 99.66666666666666, 390.0, 39.0, 515.0, 87.0, 536.0, 204.0, 551.0, 270.0)

def create_paths_between_two_paths(image,layer,paths):
	#pdb.gimp_layer_resize_to_image_size(layer) # make layer same as image size to not deal with possible layer offsets
	paths = int(paths)
	#vector = pdb.gimp_image_get_active_vectors(image)
	vector = pdb.gimp_image_get_vectors_by_name(image,"from")
	vector_position = pdb.gimp_image_get_item_position(image,vector)
	pdb.gimp_message(str(vector_position) + " vector position of from")
	if vector_position == 0: #position is okay
		vectorfrom = pdb.gimp_image_get_vectors_by_name(image,"from")
		vectorto = pdb.gimp_image_get_vectors_by_name(image,"to")
	else:    #position is reversed
		vectorfrom = pdb.gimp_image_get_vectors_by_name(image,"to")
		vectorto = pdb.gimp_image_get_vectors_by_name(image,"from")
	
	ret_value = pdb.gimp_vectors_get_strokes(vectorfrom)
	ret_value2 = pdb.gimp_vectors_get_strokes(vectorto)
	#strokes = ret_value[0]
	strokeidsfrom = ret_value[1]
	strokeidsto = ret_value2[1]
	
	points_from = []
	points_to = []
	closed_ = []
	#for strokeid in strokeids:
	for i in range(0,len(strokeidsfrom)):
		strokeidfrom = strokeidsfrom[i]
		strokeidto = strokeidsto[i]
		
		ret_value_from = pdb.gimp_vectors_stroke_get_points(vectorfrom,strokeidfrom)
		#stroke_type = ret_value_from[0]
		#num_points = ret_value_from[1]
		controlpoints = ret_value_from[2]
		closed = ret_value_from[3]
		ret_value_to = pdb.gimp_vectors_stroke_get_points(vectorto,strokeidto)
		#stroke_type = ret_value_from[0]
		#num_points = ret_value_from[1]
		controlpoints_to = ret_value_to[2]
		closed_to = ret_value_to[3]
		
		#just read it into our array to manipulate later
		points_from.append(controlpoints)
		points_to.append(controlpoints_to)
		closed_.append(closed)
	

	newlayers = []
	for x in range(1, paths+1):
		newpaths = []
		for i in range(0,len(points_from)): #loop through vectors
			from_ = points_from[i]
			to_ = points_to[i]
			newpath = []
			for j in range(0,len(from_)): #loop through points
				point1 = from_[j]
				point2 = to_[j]
				newpoint = point1 + ((point2 - point1)*1.0 / (paths+1) * x)
				
				newpath.append(newpoint) #add new point on to newpath
			newpaths.append(newpath) #add new path on to newpaths
		newlayers.append(newpaths) #add new vectors layer.
		
	newlayers = list(reversed(newlayers)) #reverse the list to get right order when we add them.
	for x in range(0, len(newlayers)):
		newlayer = newlayers[x]
		
		new_vectors = pdb.gimp_vectors_new(image,str(i))
		pdb.gimp_image_insert_vectors(image,new_vectors,pdb.gimp_item_get_parent(vectorfrom),1)
		
		for i in range(0,len(newlayer)):
			path = newlayer[i]
			pdb.gimp_vectors_stroke_new_from_points(new_vectors,0,len(path),path,closed_[i])
	
register(
    "python_fu_create_paths_between_two_paths",
    "Creates new gradient by sampling pixels on active layer along active path",
    "Creates new gradient by sampling pixels on active layer along active path",
    "Tin Tran",
    "GPL",
    "May 2016",
    "<Image>/Python-Fu/Create Paths Between from and to...",
    "*",
    [
    #(PF_IMAGE, "image", "Input image", None), #current image
    #(PF_DRAWABLE, "layer", "Input layer", None), #current layer
    #(PF_FILENAME, "curvefilename","Curfile", dircurve ),
	#(PF_STRING,  "gradient_name", "New Gradient Name:", "New Gradient"),
    (PF_ADJUSTMENT, "paths", "Number Of Paths:", 10, (2, 100, 1))
	#(PF_TOGGLE, "straight",   "Straight Line Between 2 points:", 1)
    ],
    [],
    create_paths_between_two_paths)

main()